From a1feb21dc026c752f1aaf91ee4979f972c799d4d Mon Sep 17 00:00:00 2001
From: Stephen Gallagher <sgallagh@redhat.com>
Date: Thu, 18 Feb 2010 14:13:54 -0500
Subject: [PATCH 2/5] Fix licensing issues for sss_client

---
 contrib/sssd.spec.in                  |    4 +++-
 COPYING => sss_client/COPYING         |    0
 {common => sss_client}/COPYING.LESSER |    0
 sss_client/pam_sss.c                  |    6 +++---
 sss_client/pam_test_client.c          |    6 +++---
 sss_client/protos.h                   |   30 ++++++++++++++++++++++--------
 sss_client/sss_cli.h                  |   30 ++++++++++++++++++++++--------
 sss_client/sss_pam_macros.h           |   30 ++++++++++++++++++++++--------
 8 files changed, 75 insertions(+), 31 deletions(-)
 copy COPYING => sss_client/COPYING (100%)
 copy {common => sss_client}/COPYING.LESSER (100%)

diff --git a/contrib/sssd.spec.in b/contrib/sssd.spec.in
index 6ee7d35..be41b4f 100644
--- a/contrib/sssd.spec.in
+++ b/contrib/sssd.spec.in
@@ -7,7 +7,7 @@ Release: 0@PRERELEASE_VERSION@%{?dist}
 Group: Applications/System
 Summary: System Security Services Daemon
 # The entire source code is GPLv3+ except replace/ which is LGPLv3+
-License: GPLv3+ and LGPLv3+
+License: GPLv3+
 URL: http://www.freeipa.org/
 Source0: %{name}-%{version}.tar.gz
 BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
@@ -71,6 +71,7 @@ services for projects like FreeIPA.
 %package client
 Summary: SSSD Client libraries for NSS and PAM
 Group: Applications/System
+License: LGPLv3+
 
 %description client
 Provides the libraries needed by the PAM and NSS stacks to connect to the SSSD
@@ -177,6 +178,7 @@ rm -rf $RPM_BUILD_ROOT
 
 %files client -f sss_client.lang
 %defattr(-,root,root,-)
+%doc sss_client/COPYING sss_client/COPYING.LESSER
 /%{_lib}/libnss_sss.so.2
 /%{_lib}/security/pam_sss.so
 %{_mandir}/man8/pam_sss.8*
diff --git a/COPYING b/sss_client/COPYING
similarity index 100%
copy from COPYING
copy to sss_client/COPYING
diff --git a/common/COPYING.LESSER b/sss_client/COPYING.LESSER
similarity index 100%
copy from common/COPYING.LESSER
copy to sss_client/COPYING.LESSER
diff --git a/sss_client/pam_sss.c b/sss_client/pam_sss.c
index 7dff361..8fa9dac 100644
--- a/sss_client/pam_sss.c
+++ b/sss_client/pam_sss.c
@@ -5,16 +5,16 @@
     Copyright (C) 2009 Red Hat
 
     This program is free software; you can redistribute it and/or modify
-    it under the terms of the GNU General Public License as published by
+    it under the terms of the GNU Lesser General Public License as published by
     the Free Software Foundation; either version 3 of the License, or
     (at your option) any later version.
 
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-    GNU General Public License for more details.
+    GNU Lesser General Public License for more details.
 
-    You should have received a copy of the GNU General Public License
+    You should have received a copy of the GNU Lesser General Public License
     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
diff --git a/sss_client/pam_test_client.c b/sss_client/pam_test_client.c
index a088981..ef424e7 100644
--- a/sss_client/pam_test_client.c
+++ b/sss_client/pam_test_client.c
@@ -5,16 +5,16 @@
     Copyright (C) 2009 Red Hat
 
     This program is free software; you can redistribute it and/or modify
-    it under the terms of the GNU General Public License as published by
+    it under the terms of the GNU Lesser General Public License as published by
     the Free Software Foundation; either version 3 of the License, or
     (at your option) any later version.
 
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-    GNU General Public License for more details.
+    GNU Lesser General Public License for more details.
 
-    You should have received a copy of the GNU General Public License
+    You should have received a copy of the GNU Lesser General Public License
     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
diff --git a/sss_client/protos.h b/sss_client/protos.h
index adb0b7b..1c11ae6 100644
--- a/sss_client/protos.h
+++ b/sss_client/protos.h
@@ -1,12 +1,26 @@
 /*
- * System Security Services Daemon. NSS Interface
- *
- * Copyright (C) Simo Sorce 2007
- *
- * You can used this header file in any way you see fit provided copyright
- * notices are preserved.
- *
- */
+   SSSD
+
+   Client Interface for NSS and PAM.
+
+   Authors:
+        Simo Sorce <ssorce@redhat.com>
+
+   Copyright (C) Red Hat, Inc 2007
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU Lesser General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
 
 #if 0
 /* SHADOW database NSS interface */
diff --git a/sss_client/sss_cli.h b/sss_client/sss_cli.h
index 7c18e1c..58f47f6 100644
--- a/sss_client/sss_cli.h
+++ b/sss_client/sss_cli.h
@@ -1,12 +1,26 @@
 /*
- * System Security Services Daemon. Client Interface for NSS and PAM.
- *
- * Copyright (C) Simo Sorce 2007
- *
- * You can used this header file in any way you see fit provided copyright
- * notices are preserved.
- *
- */
+   SSSD
+
+   Client Interface for NSS and PAM.
+
+   Authors:
+        Simo Sorce <ssorce@redhat.com>
+
+   Copyright (C) Red Hat, Inc 2007
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU Lesser General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
 
 #ifndef _SSSCLI_H
 #define _SSSCLI_H
diff --git a/sss_client/sss_pam_macros.h b/sss_client/sss_pam_macros.h
index 5277acd..198633c 100644
--- a/sss_client/sss_pam_macros.h
+++ b/sss_client/sss_pam_macros.h
@@ -1,12 +1,26 @@
 /*
- * System Security Services Daemon. Client Interface for NSS and PAM.
- *
- * Copyright (C) Stephen Gallagher 2009
- *
- * You can used this header file in any way you see fit provided copyright
- * notices are preserved.
- *
- */
+   SSSD
+
+   Client Interface for NSS and PAM.
+
+   Authors:
+        Stephen Gallagher <sgallagh@redhat.com>
+
+   Copyright (C) Red Hat, Inc 2009
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU Lesser General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
 
 #ifndef _SSS_PAM_MACROS_H
 #define _SSS_PAM_MACROS_H
-- 
1.6.6